%%% fake report?
\ProvidesClass{myreport}[2023-12-01, v01]

\LoadClass[a4paper,11pt,chapter,twoside,openany]{oblivoir}

\RequirePackage[a4]{fapapersize}
\evenmarginsameasodd

\RequirePackage{iftex}
\ifx\ifXeTeX\ifLuaTeX
\let\envfont\ttfamily
\else
\setkomainfont(Noto Serif CJK KR)[
	Scale=MatchUppercase,
	SmallCapsFont={UnGraphic},
	SmallCapsFeatures={Scale=MatchLowercase}
]
\setkosansfont(Noto Sans CJK KR)[Scale=MatchUppercase]
\usepackage{libertine}
\setmonofont{Inconsolatazi4}
\setkomonofont(D2Coding)[Scale=.92]
\newfontfamily\envfont{TeX Gyre Cursor}[Scale=.9]
\fi

\usepackage{xcolor}
\usepackage{graphicx}
\graphicspath{{./}{./images/}}

\let\cleartorecto\clearpage
\let\cleartoverso\clearpage

\newcommand*\pkg[1]{\textsf{#1}}
\newcommand*\doc[1]{\textsc{\color{magenta2}#1}}
\newcommand*\env[1]{<{\envfont #1}>}
\newcommand*\kemph[1]{\dotemph{\em #1}}
\newcommand*\opt[1]{\texttt{#1}}

\ExplSyntaxOn
%%% srcandtext
	\skip_new:N \g_preexample_skip
	\skip_gset:Nn \g_preexample_skip { 0pt plus 1pt minus 1pt }

	\RequirePackage [most] { tcolorbox }
	\tcbuselibrary{minted,breakable}
	\tcbset{
		listing~engine=minted,
		colframe=cyan,
		bicolor,
		colbacklower=white,
		colback=cyan!5!white,
		minted~options={tabsize=4,
			fontsize=\normalsize,breaklines},
	}
	
	\NewDocumentEnvironment { exampleonly } {}
    {
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
        \tcblisting {listing~only,breakable,after={\par\normalcolor}}
    }{
        \endtcblisting
        \relax
    }

    \NewDocumentEnvironment {exampleside} {}
    {%
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
        \tcblisting{listing~side~text,
        	righthand~width=.36\textwidth,after={\par\normalcolor}}
    }{%
        \endtcblisting
    }

    \NewDocumentEnvironment {examplebelow} {}
    {%
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
	    \tcblisting{breakable,after={\par\normalcolor}}
    }{%
        \endtcblisting
    }

    \NewDocumentEnvironment {codedemo*} {}
    {%
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
        \tcblisting{listing~side~text,
        	righthand~width=.36\textwidth,colframe=gray,colback=yellow!8,after={\par\normalcolor}}
    }{%
        \endtcblisting
    }

    \NewDocumentEnvironment {codedemo} {}
    {%
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
	    \tcblisting{breakable,colframe=gray,colback=yellow!8,
	    	after={\par\normalcolor}}
    }{%
        \endtcblisting
    }

	\NewDocumentEnvironment { codeonly } {}
    {
        \par
        \vspace { \g_preexample_skip }
%        \renewcommand\baselinestretch{ \opt_bvlskip_tl }
		\SingleSpacing
        \tcblisting {listing~only,colframe=gray,breakable,colback=yellow!8,after={\par\normalcolor}}
    }{
        \endtcblisting
        \relax
    }

\keys_define:nn { mrtitlepage }
{
	title	.tl_set:N = \titlepage_title_tl,
	author	.tl_set:N = \titlepage_author_tl,
	date	.tl_set:N = \titlepage_date_tl
}

\NewDocumentCommand \MakeTitlepage { o m }
{
	\keys_set:nn { mrtitlepage } { #2 }
	\title{\titlepage_title_tl}
	\author{\titlepage_author_tl}
	\tl_if_empty:NF \titlepage_date_tl {\date{\titlepage_date_tl}}
	
	\begin{titlingpage*}
	\titlingpageend{\clearforchapter}{\clearforchapter}
	\calccentering{\unitlength}
	\aliaspagestyle{titlingpage}{empty}
	\begin{adjustwidth}{\unitlength}{-\unitlength}
	\maketitle
	\IfValueT { #1 } {
		\vspace{2\baselineskip}
		#1
	}
	\end{adjustwidth}
	\end{titlingpage*}	
}

\NewDocumentCommand \kwave {} { {\hangulfontspec{HANBatang-LVT.ttf}\symbol{"223C} } }

\ExplSyntaxOff

\endinput
